-- ==============================================================

--                                           MagicRepair 1.0.3

--                                         File: MagicRepair.lua

-- ==============================================================

local L = LibStub("AceLocale-3.0"):GetLocale("MagicRepair")
setmetatable( L, { __index = function(t, text) return text end })

Author = "legrandseb2212"
NumVersion = "1.0.3"
GameVersion = "5.1.0"

function mr_frame()

	frame_magic_repair:SetScript("Onevent", mr_event);
	frame_magic_repair:RegisterEvent("MERCHANT_SHOW");
	frame_magic_repair:RegisterEvent("VARIABLES_LOADED");
	SLASH_MAGICREPAIR1, SLASH_MAGICREPAIR2 = '/mr', '/magicrepair';
	
end

function SlashCmdList.MAGICREPAIR(msg, editbox)
	
	if (msg == L["ownonly"] ) then MRMode = L["ownonly"] mrConfig();
	elseif ( msg == L["own"] ) then MRMode = L["own"] mrConfig();
	elseif ( msg == L["guild"] ) then MRMode = L["guild"] mrConfig();
	elseif ( msg == L["guildonly"] ) then MRMode = L["guildonly"] mrConfig();
	elseif ( msg == L["off"] ) then MRMode = L["off"] mrConfig();
	elseif ( msg == L["config"] ) then mrConfig();
	elseif ( msg == L["help"] ) then DEFAULT_CHAT_FRAME:AddMessage(L["/mr [ ownonly / own / guild / guildonly / off / config ]"],255,255,0); 
	else DEFAULT_CHAT_FRAME:AddMessage("|cFFF88017MagicRepair|r : "..L["/mr help"],255,255,0);
	
	end
	
end

function mr_event(self, event)

	if (event == "VARIABLES_LOADED") then
	
		MRLoadVariables();
		mrConfig();
		
	end

	if (event == "MERCHANT_SHOW" and CanMerchantRepair() == 1) then
	
		repairAllCost, canRepair = GetRepairAllCost();
	
		if (canRepair == 1) then
		
			if(MRMode == L["ownonly"]) then
				if( repairAllCost <= GetMoney() ) then
					RepairAllItems(0);
					DEFAULT_CHAT_FRAME:AddMessage("|cFFF88017MagicRepair|r : |cFF00FF00" ..L["Your items have been repaired for "].. "|r: " ..parseCopper(repairAllCost,","));
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cFFF88017MagicRepair|r : |cFFFF0000" ..L["You don't have enough money for repair !"].. "|r");
				end
			end
			
			if(MRMode == L["own"]) then
				if( repairAllCost <= GetMoney() ) then
					RepairAllItems(0);
					DEFAULT_CHAT_FRAME:AddMessage("|cFFF88017MagicRepair|r : |cFF00FF00" ..L["Your items have been repaired for "].. "|r: " ..parseCopper(repairAllCost,","));
				elseif( repairAllCost <= GetGuildBankMoney() ) then
					RepairAllItems(1);
					DEFAULT_CHAT_FRAME:AddMessage("|cFFF88017MagicRepair|r : |cFF00FF00" ..L["Your items have been repaired with the guild for "].. "|r: " ..parseCopper(repairAllCost,","));
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cFFF88017MagicRepair|r : |cFFFF0000" ..L["You don't have enough money for repair !"].. "|r");
				end
			end

			if(MRMode == L["guild"]) then
				if( repairAllCost <= GetGuildBankMoney() ) then
					RepairAllItems(1);
					DEFAULT_CHAT_FRAME:AddMessage("|cFFF88017MagicRepair|r : |cFF00FF00" ..L["Your items have been repaired with the guild for "].. "|r: " ..parseCopper(repairAllCost,","));
				elseif( repairAllCost <= GetMoney() ) then
					RepairAllItems(0);
					DEFAULT_CHAT_FRAME:AddMessage("|cFFF88017MagicRepair|r : |cFF00FF00" ..L["Your items have been repaired for "].. "|r: " ..parseCopper(repairAllCost,","));
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cFFF88017MagicRepair|r : |cFFFF0000" ..L["You don't have enough money for repair !"].. "|r");
				end
			end
			
			if(MRMode == L["guildonly"]) then
				if( repairAllCost <= GetGuildBankMoney() ) then
					RepairAllItems(1);
					DEFAULT_CHAT_FRAME:AddMessage("|cFFF88017MagicRepair|r : |cFF00FF00" ..L["Your items have been repaired with the guild for "].. "|r: " ..parseCopper(repairAllCost,","));
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cFFF88017MagicRepair|r : |cFFFF0000" ..L["There is not enough money in the guild for you fix it !"].. "|r");
				end
			end
			
		end
		
	end

end


function mrConfig()

	local msgtext = "";
	if(MRMode == L["ownonly"]) then msgtext = L["Repair only from own money"] ; end
	if(MRMode == L["own"]) then msgtext = L["Try to repair from own money first, repair from guild bank if fails"] ; end
	if(MRMode == L["guild"]) then msgtext = L["Try to repair from guild bank first, repair from own money if fails"] ; end
	if(MRMode == L["guildonly"]) then msgtext = L["Repair only from guild bank"] ; end
	if(MRMode == L["off"]) then msgtext = L["Automatic repairs off"] ; end
	
	DEFAULT_CHAT_FRAME:AddMessage(L["MagicRepair mode: "] ..msgtext,255,255,0);
	
end

function parseCopper(repair)

    local gold = math.floor(repair / 10000);
	local silver = math.floor((repair % 10000) / 100);
	local copper = (repair % 10000) % 100;
    if (gold > 0 and silver > 0 and copper > 0) then
		return format(GOLD_AMOUNT_TEXTURE.." "..SILVER_AMOUNT_TEXTURE.." "..COPPER_AMOUNT_TEXTURE, gold, 0, 0, silver, 0, 0, copper, 0, 0)
	elseif (gold > 0 and silver > 0 and copper == 0) then
		return format(GOLD_AMOUNT_TEXTURE.." "..SILVER_AMOUNT_TEXTURE, gold, 0, 0, silver, 0, 0)
    elseif (gold > 0 and silver == 0 and copper > 0) then
		return format(GOLD_AMOUNT_TEXTURE.." "..COPPER_AMOUNT_TEXTURE, gold, 0, 0, copper, 0, 0)
	elseif (gold == 0 and silver > 0 and copper > 0) then
		return format(SILVER_AMOUNT_TEXTURE.." "..COPPER_AMOUNT_TEXTURE, silver, 0, 0, copper, 0, 0)
	elseif (gold > 0 and silver == 0 and copper == 0) then
		return format(GOLD_AMOUNT_TEXTURE, gold, 0, 0)	
	elseif (gold == 0 and silver > 0 and copper == 0) then	
		return format(SILVER_AMOUNT_TEXTURE, silver, 0, 0)
	else
		return format(COPPER_AMOUNT_TEXTURE, copper, 0, 0)
	end
end

function MRLoadVariables()

	if MRMode == nil then
		MRMode = L["ownonly"];
	end
    
    if MROff == nil then
        MROff = true;
    end
	
	if MROwnonly == nil then
		MROwnonly = true;
	end
	
	if MROwn == nil then
		MROwn = false;
	end
	
	if MRGuild == nil then
		MRGuild = false;
	end
	
	if MRGuildonly == nil then
		MRGuildonly = false;
	end
        
end

function CheckedOff()

		MROff = false
		MROwnonly = false
		MROwn = false
		MRGuild = false
		MRGuildonly = false
		MRMode = L["off"]
	    mrConfig();
		
end

function MRToggleOff()

    if MROff then
	    CheckedOff();
    else
		MROff = true	
		MROwnonly = true
		MROwn = false
		MRGuild = false
		MRGuildonly = false
		MRMode = L["ownonly"]
		mrConfig();
    end    

end

function MRToggleOwnonly()

    if MROwnonly then
	    CheckedOff();
    else
	   MROff = true	
		MROwnonly = true
		MROwn = false
		MRGuild = false
		MRGuildonly = false
		MRMode = L["ownonly"]
		mrConfig();
    end    

end

function MRToggleOwn()

    if MROwn then
	    CheckedOff();
    else
	    MROff = true	
		MROwnonly = false
		MROwn = true
		MRGuild = false
		MRGuildonly = false
		MRMode = L["own"]
		mrConfig();
    end    

end

function MRToggleGuild()

    if MRGuild then
	    CheckedOff();
    else
	    MROff = true	
		MROwnonly = false
		MROwn = false
		MRGuild = true
		MRGuildonly = false
		MRMode = L["guild"]
		mrConfig();
    end    

end

function MRToggleGuildonly()

    if MRGuildonly then
	    CheckedOff();
    else
	    MROff = true	
		MROwnonly = false
		MROwn = false
		MRGuild = false
		MRGuildonly = true
		MRMode = L["guildonly"]
		mrConfig();
    end    

end